struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

attribute vec3 aPosition;
attribute vec3 aNormal;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform Material uMat;
uniform vec4 uLightPos;
uniform vec4 uCamPos;

varying vec3 vColor;
varying vec4 normal;
varying vec4 light;
varying vec4 view;

attribute vec2 aTexCoord;
varying vec2 vTexCoord;


void main() {
  vec4 vPosition;

  vPosition = uModelMatrix * vec4(aPosition.x, aPosition.y, aPosition.z, 1);

  normal = normalize(uModelMatrix * vec4(aNormal.x, aNormal.y, aNormal.z, 0));

  //normal = uViewMatrix * normal;

  light = normalize(uLightPos - vPosition);

  view = normalize(uCamPos - vPosition);

  vPosition = uViewMatrix * vPosition;
  gl_Position = uProjMatrix * vPosition;
  
  vTexCoord = aTexCoord;
}
